% Matlab code GGM_gait_feature 
% Input: data  set of 3-dim gait time series of length for p joints
% (originally from extracted database MoCap CMU http://mocap.cs.cmu.edu/
% Uses package  penalized from W.H. McIlhagga, 2016 
clear all;
clc; % clear command window
load gait_seriesM.txt -ascii;
series = load('gait_seriesM.txt');
% series is a matrix 3*p x n 
% 1st row are time values of  x-coordinate x_1 
% 2st row are time values of  y-coordinate x_1 
% 3rd row are time values of  z-coordinate x_1 
% ......
% (3*(p-1) + 1)st row are time values of  x-coordinate x_p 
% (3*(p-1) + 2)nd row are time values of  y-coordinate x_p 
% (3*(p-1) + 3)rd row are time values of  z-coordinate x_p 

Filename = 'Joints_gait.mat';
save(Filename);
[p3,n]=size(series); % the lenght of the time series, now  with x,y,z-coordinates after each other
datasave=[];
d=1; % considered lag, intere from 1 to 4
lambda=5; % for adaptive lasso
Max_Lag= d;
p=floor(p3/3);
adj_AD=zeros(p,p);      
X= CreatematrixX_3D(series, p,n, d);  
disp(strcat('Lag = ',num2str(d))); 

 for i=1:p     
     j=1; k=1;
 while  (j <=(n-d)) 
     t(k,i)     = series(3*(i-1)+1,j+d);
     t(k+1,i)   = series(3*(i-1)+2,j+d);
     t(k+2,i)   = series(3*(i-1)+3, j+d);
     j=j+1; k=k+3;
 end; 
    model= glm_gaussian(t(:,i),X,'nointercept');
             options = statset(statset('glmfit'));
             options.MaxIter=10000;
             %initial weights
             b = glmfit(X,t(:,i),'normal','Options',options,'link','identity','constant','off');   
       
  fit_CV_glmfit= cv_penalized(model, @p_adaptive, 'lambdamax', lambda,'lambdaminratio', 0.01,'gamma',1, 'adaptivewt',{b});   
 
        b_opt=fit_CV_glmfit.bestbeta;
        if isempty(b_opt)
            disp('Isempty');
            b_opt=zeros(p,d);
        end
         threshold=0.01;         
         for j=1:p
         for k=(d*j-d+1):(d*j) 
             if (abs(b_opt(k,1)) >= threshold & (i~=j)) adj_AD(i,j) = 1; end; end              
         end
 
 end
     
  %% Save and Plot
        resultFile=strcat('Interactions_among_joints_Lag',num2str(d),'.mat')
        save(resultFile);            
%          labels = {'1','2','3','4','5','6','7','8','9','10',...
%              '11','12','13','14','15','16','17','18','19','20',...
%              '21','22','23','24','25','26','27','28'};
 labels = {'lfemur','ltibia','lfoot','ltoes','rfemur','rtibia','rfoot','rtoes','lowback','upback','thorax','lowneck','upneck', 'head','lclav','lhum','lrad','lwrist','lhand','lfing','lthumb','rclav','rhum','rrad','rwrist', 'rhand','rfing','rthumb'};

resultFile1  = strcat('adj_AD.mat');
save(resultFile1);
PlotScript_gait(resultFile1,labels);
        
